﻿Class Window1
    Const WDG_ACTION_IGNORE = 0
    Const WDG_ACTION_DISABLE = 1
    Const WDG_ACTION_SOFT_RESTART = 2
    Const WDG_ACTION_MOSTLY_SOFT_RESTART = 4
    Const PCI_WDG_CSM_RATE = 2.08333
    Const P104_WDG_CSM_RATE = 2.08333
    Const ISA_WDG_CSM_RATE = 0.894886

    Private Declare Function GetNumCards Lib "AIOWDM" Alias "VBGetNumCards" () As UInt32
    Private Declare Function QueryCardInfo Lib "AIOWDM" Alias "VBQueryCardInfo" (ByVal CardNum As UInt32, ByRef pDeviceID As UInt32, ByRef pBase As UInt32, ByRef pNameSize As UInt32, ByVal pName As String) As UInt32
    Private Declare Function WaitForIRQ Lib "AIOWDM" Alias "VBWaitForIRQ" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function AbortRequest Lib "AIOWDM" Alias "VBAbortRequest" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function CloseCard Lib "AIOWDM" Alias "VBCloseCard" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function COSWaitForIRQ Lib "AIOWDM" Alias "VBCOSWaitForIRQ" (ByVal CardNum As UInt32, ByVal PPIs As UInt32, ByRef pData As Byte) As UInt32
    Private Declare Function WDGInit Lib "AIOWDM" Alias "VBWDGInit" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function WDGHandleIRQ Lib "AIOWDM" Alias "VBWDGHandleIRQ" (ByVal CardNum As UInt32, ByVal Action As UInt32) As UInt32
    Private Declare Function WDGSetTimeout Lib "AIOWDM" Alias "VBWDGSetTimeout" (ByVal CardNum As UInt32, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double
    Private Declare Function WDGPet Lib "AIOWDM" Alias "VBWDGPet" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function WDGReadTemp Lib "AIOWDM" Alias "VBWDGReadTemp" (ByVal CardNum As UInt32) As Double
    Private Declare Function WDGReadStatus Lib "AIOWDM" Alias "VBWDGReadStatus" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function WDGStart Lib "AIOWDM" Alias "VBWDGStart" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function WDGStop Lib "AIOWDM" Alias "VBWDGStop" (ByVal CardNum As UInt32) As UInt32
    Private Declare Function EmergencyReboot Lib "AIOWDM" Alias "VBEmergencyReboot" () As UInt32
    Private Declare Function WDGSetResetDuration Lib "AIOWDM" Alias "VBWDGSetResetDuration" (ByVal CardNum As UInt32, ByVal Milliseconds As Double, ByVal MHzClockRate As Double) As Double

    '8-bit
    Private Declare Function InPortB Lib "AIOWDM" Alias "VBInPortB" (ByVal Port As UInt32) As UInt16
    Private Declare Function OutPortB Lib "AIOWDM" Alias "VBOutPortB" (ByVal Port As UInt32, ByVal Value As Byte) As UInt16

    '16-bit
    Private Declare Function InPort Lib "AIOWDM" Alias "VBInPort" (ByVal Port As UInt32) As UInt16
    Private Declare Function OutPort Lib "AIOWDM" Alias "VBOutPort" (ByVal Port As UInt32, ByVal Value As UInt16) As UInt16

    '32-bit
    Private Declare Function InPortL Lib "AIOWDM" Alias "VBInPortL" (ByVal Port As UInt32) As UInt32
    Private Declare Function OutPortL Lib "AIOWDM" Alias "VBOutPortL" (ByVal Port As UInt32, ByVal Value As UInt32) As UInt16
    Private Declare Function InPortDWord Lib "AIOWDM" Alias "VBInPortDWord" (ByVal Port As UInt32) As UInt32
    Private Declare Function OutPortDWord Lib "AIOWDM" Alias "VBOutPortDWord" (ByVal Port As UInt32, ByVal Value As UInt32) As UInt16

    '8-bit Relative
    Private Declare Function RelInPortB Lib "AIOWDM" Alias "VBRelInPortB" (ByVal Cardnum As UInt32, ByVal Port As UInt32) As UInt16
    Private Declare Function RelOutPortB Lib "AIOWDM" Alias "VBRelOutPortB" (ByVal Cardnum As UInt32, ByVal Port As UInt32, ByVal Value As Byte) As UInt16

    '16-bit Relative
    Private Declare Function RelInPort Lib "AIOWDM" Alias "VBRelInPort" (ByVal Cardnum As UInt32, ByVal Port As UInt32) As UInt16
    Private Declare Function RelOutPort Lib "AIOWDM" Alias "VBRelOutPort" (ByVal Cardnum As UInt32, ByVal Port As UInt32, ByVal Value As UInt16) As UInt16

    '32-bit Relative
    Private Declare Function RelInPortL Lib "AIOWDM" Alias "VBRelInPortL" (ByVal Cardnum As UInt32, ByVal Port As UInt32) As UInt32
    Private Declare Function RelOutPortL Lib "AIOWDM" Alias "VBRelOutPortL" (ByVal Cardnum As UInt32, ByVal Port As UInt32, ByVal Value As UInt32) As UInt16
    Private Declare Function RelInPortDWord Lib "AIOWDM" Alias "VBRelInPortDWord" (ByVal Cardnum As UInt32, ByVal Port As UInt32) As UInt32
    Private Declare Function RelOutPortDWord Lib "AIOWDM" Alias "VBRelOutPortDWord" (ByVal Cardnum As UInt32, ByVal Port As UInt32, ByVal Value As UInt32) As UInt16


    Dim CardNum As Integer = 0
    Const OffsetForPortA = 0
    Const OffsetForPortB = 1
    Const OffsetForPortC = 2
    Const OffsetForPortDirectionControl = 3

    Const DIO_OUTPUT = 0
    Const DIO_INPUT = 1

    Friend WithEvents Timer1 As New System.Windows.Forms.Timer
    Private Function ConvertConfigurationToByte(ByVal PA As Byte, ByVal PB As Byte, ByVal PCLo As Byte, ByVal PCHi As Byte)
        ConvertConfigurationToByte = &H80 Or (PA * 2 ^ 4) Or (PB * 2 ^ 1) Or (PCLo * 2 ^ 0) Or (PCHi * 2 ^ 3)
    End Function
    Private Function IntToBin(ByVal V As Long, ByVal bits As Integer) As String
        Dim i As UInt16
        Dim S As String = Space$(8)

        For i = 0 To bits - 1
            If V And ((2 ^ i)) Then S = "1" + S Else S = "0" + S
        Next
        IntToBin = S
    End Function

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Static Dim NextValueToWrite As Byte = &H1
        NextValueToWrite = NextValueToWrite * 2 And &HFF
        If NextValueToWrite = 0 Then NextValueToWrite = &H1
        RelOutPortB(CardNum, OffsetForPortA, NextValueToWrite)
        LabelPortAWrittenValue.Content = IntToBin(NextValueToWrite, 8)

        LabelPortAValueRead.Content = IntToBin(RelInPortB(CardNum, OffsetForPortA), 8)  ' display 8 bits per value in binary ...
        LabelPortBValueRead.Content = IntToBin(RelInPortB(CardNum, OffsetForPortB), 8)  '
        LabelPortCValueRead.Content = IntToBin(RelInPortB(CardNum, OffsetForPortC), 8)  ' ... for each port

    End Sub

    Private Sub Grid1_Loaded(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Grid1.Loaded
        Timer1.Interval = 250
        Timer1.Enabled = False

    End Sub
    Private Sub BeginSample()
        CardName.Content = "Walking Bit and Readback"
        Memo1.Clear()
        Memo1.AppendText("Each time the timer event fires (4 times a second) a new value will be written to Port A.  The Port A readback should show a walking bit pattern." & Chr(13) & Chr(10) & Chr(13) & Chr(10))
        Memo1.AppendText("If the Port A display does not show the same value readback as is shown as being written, your board may not be an 8255 compatible device." & Chr(13) & Chr(10) & Chr(13) & Chr(10))
        Memo1.AppendText("The readings for Port B and Port C (hi and lo) are simply displayed.  If you connect signals to these pins you should be able to see them." & Chr(13) & Chr(10))

        'Configure the 8255 for Port A output, the rest of the ports Input
        RelOutPortB(CardNum, OffsetForPortDirectionControl, ConvertConfigurationToByte(DIO_OUTPUT, DIO_INPUT, DIO_INPUT, DIO_INPUT))

        Timer1.Enabled = True
        Button1.Content = "Exit"
        Button1.Tag = 0
    End Sub
    Private Sub OverrideAndRun()
        Dim DeviceID As UInt32
        Dim Base As UInt32
        Dim NameString As String
        Dim NameLength As UInt32

        CardNum = 0
        DeviceID = 0
        NameLength = 255
        NameString = Space$(NameLength)
        QueryCardInfo(CardNum, DeviceID, Base, NameLength, NameString) 'retrieve interesting facts about card
        CardName.Content = "Using PCI Device: " + NameString

        Memo1.Clear()
        Memo1.AppendText("This sample is going to continually display the data read from the first three addresses on the card - these are normally the first three ports: A, B, and C. " & Chr(13) & Chr(10))
        Memo1.AppendText("Additionally, the sample will write a walking bit pattern to the first port. " & Chr(13) & Chr(10) & Chr(13) & Chr(10))
        Memo1.AppendText("Press 'Run Sample; to continue.")
        Button1.Content = "Run Sample"
        Button1.Tag = 2
    End Sub

    Private Sub Grid1_Initialized(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Grid1.Initialized
        Dim Found As UInt32
        Dim DeviceID As UInt32
        Dim Base As UInt32
        Dim NameString As String
        Dim NameLength As UInt32
        Dim i As UInt16

        Found = GetNumCards()

        If Found < 1 Then
            CardName.Content = "Error, cannot continue."
            Memo1.AppendText("No PCI cards using the AIOWDM driver package were found.")
            Memo1.AppendText("Please confirm the PCI device you're trying to use with this sample has been installed and is visible in Device Manager.")
        ElseIf Found > 1 Then
            CardName.Content = "Warning.  You probably should not continue."
            Memo1.AppendText("This sample is designed to operate a single PCI card." & Chr(13) & Chr(10))

            For i = 0 To Found - 1
                DeviceID = 0
                NameLength = 255
                NameString = Space$(NameLength)
                QueryCardInfo(i, DeviceID, Base, NameLength, NameString)    'retrieve interesting facts about card
                Memo1.AppendText("Card #" + (i + 1) + ": " + NameString + ".")
            Next
            Memo1.AppendText(Chr(13) & Chr(10) & "A total of " + Found + " AIOWDM driver based PCI devices were detected." & Chr(13) & Chr(10))
            Memo1.AppendText("This program will operate the FIRST device it detected (#1), with DeviceID: " + Hex(DeviceID) & Chr(13) & Chr(10))
            Memo1.AppendText("Doing so may have very unexpected and potentially dangerous results if the board is not simply an 8255 compatible PCI device, with the 8255 registers located at offset zero." & Chr(13) & Chr(10))
            Button1.Content = "OVERRIDE AND RUN - I accept the risks"
            Button1.Tag = 1
        Else 'Found = 1
            CardNum = 0
            DeviceID = 0
            NameLength = 0
            NameString = ""
            QueryCardInfo(i, DeviceID, Base, NameLength, NameString)    'retrieve interesting facts about card
            CardName.Content = "Success. Found one PCI Device: " + NameString
            Memo1.AppendText("Please do not have any application wiring attached while you use this sample, at least until you are very familiar with its operation." & Chr(13) & Chr(10) & Chr(13) & Chr(10))
            Memo1.AppendText("This sample is going to continually display the data read from the first three addresses on the card - these are normally the first three ports: A, B, and C. " & Chr(13) & Chr(10))
            Memo1.AppendText("Additionally, the sample will write a walking bit pattern to the first port." & Chr(13) & Chr(10) & Chr(13) & Chr(10))
            Memo1.AppendText("Press 'Run Sample' to continue.")
            Button1.Content = "Run Sample"
            Button1.Tag = 2
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Select Case Button1.Tag
            Case 0 : Close()
            Case 2 : BeginSample()
            Case 1 : OverrideAndRun()
        End Select
    End Sub
End Class
